<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/clap-3.2.16/src/builder/arg_settings.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>arg_settings.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container"><img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container">
                    <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../clap/index.html">
                        <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>

<span class="comment">// Std</span>
<span class="kw">use</span> <span class="ident">std::ops::BitOr</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">std::str::FromStr</span>;

<span class="comment">// Third party</span>
<span class="kw">use</span> <span class="ident">bitflags::bitflags</span>;

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Arg</span>;

<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ArgFlags</span>(<span class="ident">Flags</span>);

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">ArgFlags</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::empty</span>()
    }
}

<span class="doccomment">/// Various settings that apply to arguments and may be set, unset, and checked via getter/setter</span>
<span class="doccomment">/// methods [`Arg::setting`], [`Arg::unset_setting`], and [`Arg::is_set`]. This is what the</span>
<span class="doccomment">/// [`Arg`] methods which accept a `bool` use internally.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Arg`]: crate::Arg</span>
<span class="doccomment">/// [`Arg::setting`]: crate::Arg::setting()</span>
<span class="doccomment">/// [`Arg::unset_setting`]: crate::Arg::unset_setting()</span>
<span class="doccomment">/// [`Arg::is_set`]: crate::Arg::is_set()</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ArgSettings</span> {
    <span class="doccomment">/// Deprecated, replaced with [`Arg::required`] and [`Arg::is_required_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::required` and `Arg::is_required_set`&quot;</span>
        )
    )]</span>
    <span class="ident">Required</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::multiple_values`] and [`Arg::is_multiple_values_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::multiple_values` and `Arg::`is_multiple_values_set`&quot;</span>
        )
    )]</span>
    <span class="ident">MultipleValues</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::action`] ([Issue #3772](https://github.com/clap-rs/clap/issues/3772))</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::action` (Issue #3772)&quot;</span>)
    )]</span>
    <span class="ident">MultipleOccurrences</span>,
    <span class="doccomment">/// Deprecated, see [`ArgSettings::MultipleOccurrences`] (most likely what you want) and</span>
    <span class="doccomment">/// [`ArgSettings::MultipleValues`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Split into `Arg::multiple_occurrences` (most likely what you want)  and `Arg::multiple_values`&quot;</span>
        )
    )]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">Multiple</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::value_parser(NonEmptyStringValueParser::new())`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::value_parser(NonEmptyStringValueParser::new())`&quot;</span>
        )
    )]</span>
    <span class="ident">ForbidEmptyValues</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::global`] and [`Arg::is_global_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::global` and `Arg::is_global_set`&quot;</span>
        )
    )]</span>
    <span class="ident">Global</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::hide`] and [`Arg::is_hide_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::hide` and `Arg::is_hide_set`&quot;</span>
        )
    )]</span>
    <span class="ident">Hidden</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::takes_value`] and [`Arg::is_takes_value_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::takes_value` and `Arg::is_takes_value_set`&quot;</span>
        )
    )]</span>
    <span class="ident">TakesValue</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::use_value_delimiter`] and</span>
    <span class="doccomment">/// [`Arg::is_use_value_delimiter_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::use_value_delimiter` and `Arg::is_use_value_delimiter_set`&quot;</span>
        )
    )]</span>
    <span class="ident">UseValueDelimiter</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::next_line_help`] and [`Arg::is_next_line_help_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::next_line_help` and `Arg::is_next_line_help_set`&quot;</span>
        )
    )]</span>
    <span class="ident">NextLineHelp</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::require_value_delimiter`] and</span>
    <span class="doccomment">/// [`Arg::is_require_value_delimiter_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::require_value_delimiter` and `Arg::is_require_value_delimiter_set`&quot;</span>
        )
    )]</span>
    <span class="ident">RequireDelimiter</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::hide_possible_values`] and</span>
    <span class="doccomment">/// [`Arg::is_hide_possible_values_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::hide_possible_values` and `Arg::is_hide_possible_values_set`&quot;</span>
        )
    )]</span>
    <span class="ident">HidePossibleValues</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::allow_hyphen_values`] and</span>
    <span class="doccomment">/// [`Arg::is_allow_hyphen_values_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::allow_hyphen_values` and `Arg::is_allow_hyphen_values_set`&quot;</span>
        )
    )]</span>
    <span class="ident">AllowHyphenValues</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::allow_hyphen_values`] and</span>
    <span class="doccomment">/// [`Arg::is_allow_hyphen_values_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::allow_hyphen_values` and `Arg::is_allow_hyphen_values_set`&quot;</span>
        )
    )]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">AllowLeadingHyphen</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::require_equals`] and [`Arg::is_require_equals_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::require_equals` and `Arg::is_require_equals_set`&quot;</span>
        )
    )]</span>
    <span class="ident">RequireEquals</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::last`] and [`Arg::is_last_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::last` and `Arg::is_last_set`&quot;</span>
        )
    )]</span>
    <span class="ident">Last</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::hide_default_value`] and [`Arg::is_hide_default_value_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::hide_default_value` and `Arg::is_hide_default_value_set`&quot;</span>
        )
    )]</span>
    <span class="ident">HideDefaultValue</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::ignore_case`] and [`Arg::is_ignore_case_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::ignore_case` and `Arg::is_ignore_case_set`&quot;</span>
        )
    )]</span>
    <span class="ident">IgnoreCase</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::ignore_case`] and [`Arg::is_ignore_case_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::ignore_case` and `Arg::is_ignore_case_set`&quot;</span>
        )
    )]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">CaseInsensitive</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::hide_env`] and [`Arg::is_hide_env_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::hide_env` and `Arg::is_hide_env_set`&quot;</span>
        )
    )]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
    <span class="ident">HideEnv</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::hide_env_values`] and [`Arg::is_hide_env_values_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::hide_env_values` and `Arg::is_hide_env_values_set`&quot;</span>
        )
    )]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
    <span class="ident">HideEnvValues</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::hide_short_help`] and [`Arg::is_hide_short_help_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::hide_short_help` and `Arg::is_hide_short_help_set`&quot;</span>
        )
    )]</span>
    <span class="ident">HiddenShortHelp</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::hide_long_help`] and [`Arg::is_hide_long_help_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::hide_long_help` and `Arg::is_hide_long_help_set`&quot;</span>
        )
    )]</span>
    <span class="ident">HiddenLongHelp</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::allow_invalid_utf8`] and [`Arg::is_allow_invalid_utf8_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::allow_invalid_utf8` and `Arg::is_allow_invalid_utf8_set`&quot;</span>
        )
    )]</span>
    <span class="ident">AllowInvalidUtf8</span>,
    <span class="doccomment">/// Deprecated, replaced with [`Arg::exclusive`] and [`Arg::is_exclusive_set`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `Arg::exclusive` and `Arg::is_exclusive_set`&quot;</span>
        )
    )]</span>
    <span class="ident">Exclusive</span>,
}

<span class="macro">bitflags!</span> {
    <span class="kw">struct</span> <span class="ident">Flags</span>: <span class="ident">u32</span> {
        <span class="kw">const</span> <span class="ident">REQUIRED</span>         <span class="op">=</span> <span class="number">1</span>;
        <span class="kw">const</span> <span class="ident">MULTIPLE_OCC</span>     <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">1</span>;
        <span class="kw">const</span> <span class="ident">NO_EMPTY_VALS</span>    <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">2</span>;
        <span class="kw">const</span> <span class="ident">GLOBAL</span>           <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">3</span>;
        <span class="kw">const</span> <span class="ident">HIDDEN</span>           <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">4</span>;
        <span class="kw">const</span> <span class="ident">TAKES_VAL</span>        <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">5</span>;
        <span class="kw">const</span> <span class="ident">USE_DELIM</span>        <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">6</span>;
        <span class="kw">const</span> <span class="ident">NEXT_LINE_HELP</span>   <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">7</span>;
        <span class="kw">const</span> <span class="ident">REQ_DELIM</span>        <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">9</span>;
        <span class="kw">const</span> <span class="ident">DELIM_NOT_SET</span>    <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">10</span>;
        <span class="kw">const</span> <span class="ident">HIDE_POS_VALS</span>    <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">11</span>;
        <span class="kw">const</span> <span class="ident">ALLOW_TAC_VALS</span>   <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">12</span>;
        <span class="kw">const</span> <span class="ident">REQUIRE_EQUALS</span>   <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">13</span>;
        <span class="kw">const</span> <span class="ident">LAST</span>             <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">14</span>;
        <span class="kw">const</span> <span class="ident">HIDE_DEFAULT_VAL</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">15</span>;
        <span class="kw">const</span> <span class="ident">CASE_INSENSITIVE</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">16</span>;
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
        <span class="kw">const</span> <span class="ident">HIDE_ENV_VALS</span>    <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">17</span>;
        <span class="kw">const</span> <span class="ident">HIDDEN_SHORT_H</span>   <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">18</span>;
        <span class="kw">const</span> <span class="ident">HIDDEN_LONG_H</span>    <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">19</span>;
        <span class="kw">const</span> <span class="ident">MULTIPLE_VALS</span>    <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">20</span>;
        <span class="kw">const</span> <span class="ident">MULTIPLE</span>         <span class="op">=</span> <span class="ident"><span class="self">Self</span>::MULTIPLE_OCC</span>.<span class="ident">bits</span> <span class="op">|</span> <span class="ident"><span class="self">Self</span>::MULTIPLE_VALS</span>.<span class="ident">bits</span>;
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
        <span class="kw">const</span> <span class="ident">HIDE_ENV</span>         <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">21</span>;
        <span class="kw">const</span> <span class="ident">UTF8_NONE</span>        <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">22</span>;
        <span class="kw">const</span> <span class="ident">EXCLUSIVE</span>        <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">23</span>;
        <span class="kw">const</span> <span class="ident">NO_OP</span>            <span class="op">=</span> <span class="number">0</span>;
    }
}

<span class="macro">impl_settings!</span> { <span class="ident">ArgSettings</span>, <span class="ident">ArgFlags</span>,
    <span class="ident">Required</span> =&gt; <span class="ident">Flags::REQUIRED</span>,
    <span class="ident">MultipleOccurrences</span> =&gt; <span class="ident">Flags::MULTIPLE_OCC</span>,
    <span class="ident">MultipleValues</span> =&gt; <span class="ident">Flags::MULTIPLE_VALS</span>,
    <span class="ident">Multiple</span> =&gt; <span class="ident">Flags::MULTIPLE</span>,
    <span class="ident">ForbidEmptyValues</span> =&gt; <span class="ident">Flags::NO_EMPTY_VALS</span>,
    <span class="ident">Global</span> =&gt; <span class="ident">Flags::GLOBAL</span>,
    <span class="ident">Hidden</span> =&gt; <span class="ident">Flags::HIDDEN</span>,
    <span class="ident">TakesValue</span> =&gt; <span class="ident">Flags::TAKES_VAL</span>,
    <span class="ident">UseValueDelimiter</span> =&gt; <span class="ident">Flags::USE_DELIM</span>,
    <span class="ident">NextLineHelp</span> =&gt; <span class="ident">Flags::NEXT_LINE_HELP</span>,
    <span class="ident">RequireDelimiter</span> =&gt; <span class="ident">Flags::REQ_DELIM</span>,
    <span class="ident">HidePossibleValues</span> =&gt; <span class="ident">Flags::HIDE_POS_VALS</span>,
    <span class="ident">AllowHyphenValues</span> =&gt; <span class="ident">Flags::ALLOW_TAC_VALS</span>,
    <span class="ident">AllowLeadingHyphen</span> =&gt; <span class="ident">Flags::ALLOW_TAC_VALS</span>,
    <span class="ident">RequireEquals</span> =&gt; <span class="ident">Flags::REQUIRE_EQUALS</span>,
    <span class="ident">Last</span> =&gt; <span class="ident">Flags::LAST</span>,
    <span class="ident">IgnoreCase</span> =&gt; <span class="ident">Flags::CASE_INSENSITIVE</span>,
    <span class="ident">CaseInsensitive</span> =&gt; <span class="ident">Flags::CASE_INSENSITIVE</span>,
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
    <span class="ident">HideEnv</span> =&gt; <span class="ident">Flags::HIDE_ENV</span>,
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
    <span class="ident">HideEnvValues</span> =&gt; <span class="ident">Flags::HIDE_ENV_VALS</span>,
    <span class="ident">HideDefaultValue</span> =&gt; <span class="ident">Flags::HIDE_DEFAULT_VAL</span>,
    <span class="ident">HiddenShortHelp</span> =&gt; <span class="ident">Flags::HIDDEN_SHORT_H</span>,
    <span class="ident">HiddenLongHelp</span> =&gt; <span class="ident">Flags::HIDDEN_LONG_H</span>,
    <span class="ident">AllowInvalidUtf8</span> =&gt; <span class="ident">Flags::UTF8_NONE</span>,
    <span class="ident">Exclusive</span> =&gt; <span class="ident">Flags::EXCLUSIVE</span>
}

<span class="doccomment">/// Deprecated in [Issue #3087](https://github.com/clap-rs/clap/issues/3087), maybe [`clap::Parser`][crate::Parser] would fit your use case?</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">FromStr</span> <span class="kw">for</span> <span class="ident">ArgSettings</span> {
    <span class="kw">type</span> <span class="prelude-val">Err</span> <span class="op">=</span> <span class="ident">String</span>;
    <span class="kw">fn</span> <span class="ident">from_str</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="op">&lt;</span><span class="self">Self</span> <span class="kw">as</span> <span class="ident">FromStr</span><span class="op">&gt;</span><span class="ident">::Err</span><span class="op">&gt;</span> {
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unreachable_patterns</span>)]</span>
        <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="ident">s</span>.<span class="ident">to_ascii_lowercase</span>() {
            <span class="string">&quot;required&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::Required</span>),
            <span class="string">&quot;multipleoccurrences&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::MultipleOccurrences</span>),
            <span class="string">&quot;multiplevalues&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::MultipleValues</span>),
            <span class="string">&quot;multiple&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::Multiple</span>),
            <span class="string">&quot;forbidemptyvalues&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::ForbidEmptyValues</span>),
            <span class="string">&quot;global&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::Global</span>),
            <span class="string">&quot;hidden&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::Hidden</span>),
            <span class="string">&quot;takesvalue&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::TakesValue</span>),
            <span class="string">&quot;usevaluedelimiter&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::UseValueDelimiter</span>),
            <span class="string">&quot;nextlinehelp&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::NextLineHelp</span>),
            <span class="string">&quot;requiredelimiter&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::RequireDelimiter</span>),
            <span class="string">&quot;hidepossiblevalues&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::HidePossibleValues</span>),
            <span class="string">&quot;allowhyphenvalues&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::AllowHyphenValues</span>),
            <span class="string">&quot;allowleadinghypyhen&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::AllowLeadingHyphen</span>),
            <span class="string">&quot;requireequals&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::RequireEquals</span>),
            <span class="string">&quot;last&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::Last</span>),
            <span class="string">&quot;ignorecase&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::IgnoreCase</span>),
            <span class="string">&quot;caseinsensitive&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::CaseInsensitive</span>),
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
            <span class="string">&quot;hideenv&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::HideEnv</span>),
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
            <span class="string">&quot;hideenvvalues&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::HideEnvValues</span>),
            <span class="string">&quot;hidedefaultvalue&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::HideDefaultValue</span>),
            <span class="string">&quot;hiddenshorthelp&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::HiddenShortHelp</span>),
            <span class="string">&quot;hiddenlonghelp&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::HiddenLongHelp</span>),
            <span class="string">&quot;allowinvalidutf8&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::AllowInvalidUtf8</span>),
            <span class="string">&quot;exclusive&quot;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">ArgSettings::Exclusive</span>),
            <span class="kw">_</span> =&gt; <span class="prelude-val">Err</span>(<span class="macro">format!</span>(<span class="string">&quot;unknown AppSetting: `{}`&quot;</span>, <span class="ident">s</span>)),
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">arg_settings_fromstr</span>() {
        <span class="kw">use</span> <span class="ident"><span class="kw">super</span>::ArgSettings</span>;

        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;allowhyphenvalues&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::AllowHyphenValues</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;forbidemptyvalues&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::ForbidEmptyValues</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;hidepossiblevalues&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::HidePossibleValues</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;hidden&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::Hidden</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;nextlinehelp&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::NextLineHelp</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;requiredelimiter&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::RequireDelimiter</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;required&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::Required</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;takesvalue&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::TakesValue</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;usevaluedelimiter&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::UseValueDelimiter</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;requireequals&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::RequireEquals</span>
        );
        <span class="macro">assert_eq!</span>(<span class="string">&quot;last&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(), <span class="ident">ArgSettings::Last</span>);
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;hidedefaultvalue&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::HideDefaultValue</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;ignorecase&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::IgnoreCase</span>
        );
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;hideenv&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::HideEnv</span>
        );
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;env&quot;</span>)]</span>
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;hideenvvalues&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::HideEnvValues</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;hiddenshorthelp&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::HiddenShortHelp</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;hiddenlonghelp&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::HiddenLongHelp</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;allowinvalidutf8&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::AllowInvalidUtf8</span>
        );
        <span class="macro">assert_eq!</span>(
            <span class="string">&quot;exclusive&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">unwrap</span>(),
            <span class="ident">ArgSettings::Exclusive</span>
        );
        <span class="macro">assert!</span>(<span class="string">&quot;hahahaha&quot;</span>.<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">ArgSettings</span><span class="op">&gt;</span>().<span class="ident">is_err</span>());
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="clap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>